---
title: Showcase
order: 7
---

# Showcase

`urql` wouldn't be the same without our growing and loving community of users,
maintainers and supporters. This page is specifically dedicated to all of you!

## Used by folks at

<a href="https://tripadvisor.com">
<img alt="TripAdvisor" height="60" src="./assets/logos/tripadvisor.png" />
</a>

<a href="https://github.com">
<img alt="GitHub" height="60" src="./assets/logos/github.png" />
</a>

<a href="https://egghead.io">
<img alt="Egghead" height="60" src="./assets/logos/egghead.png" />
</a>

<a href="https://gatsbyjs.org">
<img alt="Gatsby" height="60" src="./assets/logos/gatsby.png" />
</a>

<a href="https://theatlantic.com/science/">
<img alt="The Atlantic" height="60" src="./assets/logos/the-atlantic.png" />
</a>

<a href="https://www.loveholidays.com">
<img alt="loveholidays" height="60" src="./assets/logos/loveholidays.png" />
</a>

<a href="https://www.swan.io/">
<img alt="Swan" height="60" src="./assets/logos/swan.png" />
</a>

<a href="https://www.getopensocial.com">
<img alt="Open Social" height="60" src="./assets/logos/open-social.png" />
</a>

<a href="https://getsturdy.com/">
<img alt="Sturdy" height="60" src="./assets/logos/sturdy.png" />
</a>

## Articles & Tutorials

- [Egghead Course](https://egghead.io/lessons/graphql-set-up-an-urql-graphql-provider-in-react?pl=introduction-to-urql-a-react-graphql-client-faaa2bf5)
  by [Ian Jones](https://twitter.com/_jonesian).
- [How To GraphQL: React + urql](https://www.howtographql.com/react-urql/0-introduction/)

## Community packages

- [`reason-urql`](https://github.com/FormidableLabs/reason-urql): The official Reason bindings for
  `urql`.
- [`urql-persisted-queries`](https://github.com/Daniel15/urql-persisted-queries): Support for
  Apollo-style persisted queries.
- [`urql-computed-queries`](https://github.com/Drawbotics/urql-computed-exchange): An exchange to
  compute fields on-the-fly using the `@computed` directive.
- [`graphql-code-generator`](https://graphql-code-generator.com/docs/plugins/typescript-urql): A plugin
  that helps you make typesafe hooks/components with urql.
- [`urql-custom-scalars-exchange`](https://github.com/clentfort/urql-custom-scalars-exchange): An exchange
  to automatically convert scalars.
- [`@grafbase/urql-exchange`](https://github.com/grafbase/playground/tree/main/packages/grafbase-urql-exchange): URQL-exchange for handling Server Sent Events (SSE) with Grafbase GraphQL Live Queries.
